#version 110
#define float4 vec4
#define float3 vec3
#define float2 vec2
#define oUV gl_TexCoord[0]
#define tex3D texture3D
#define tex2D texture2D
#define tex1D texture1D

varying vec3 normal;
//varying vec4 position;
varying vec4 projection_position;
varying vec4 ShadowPosZ;
varying vec4 Color;

varying vec4 projection_from_camera;

varying vec2 UVcoordinates;


uniform mat4 ProjectionMatrix;
				uniform sampler2D texture2d_1;
				uniform sampler2D texture2d_2;
				uniform sampler2D texture2d_reflection;
				uniform sampler2D texture2d_3;
				uniform sampler2D texture2d_chess;
				uniform sampler2D texture2d_blob;


				uniform sampler2D texture2d_paper;
				uniform sampler2D texture2d_texturedblob;

				/*				uniform sampler3D texture3d_2;
				uniform sampler1D texture_transfer_function;
				uniform sampler1D texture_palette_function;

					
				uniform float3 VolumeSize;
				uniform float3 RelativeSize;
				uniform float3 Registration_Offset;
				uniform float pet_alpha_blending;
				uniform float3 MousePos;
				uniform int Projection_mode;
uniform float3 InVolumePosition;
				uniform float3 Windowing_Levels;

				uniform float isosurface;
uniform float Sharpening;

*/

uniform float timer1;
uniform float ttimer2;

	uniform float PosY;
	uniform float MaterialMultiplier;
uniform float ischess;



void main (void) 
{

vec4 Final_Color;
	// discard segments
///if (sin(position.z*1.5)*cos(position.y*1.5)>0.7) discard;
///if (position.y<0.5)	if (position.z<0.5)	if (position.y>0.0) discard;
if (projection_position.x>22.0) discard;
if (projection_position.x<-22.0) discard;

float4 nnormal= (normal.xyzz);
float4 projection_pos=projection_position;

projection_pos=ShadowPosZ / ShadowPosZ.w ;;


vec4 ReflCol=texture2D (texture2d_3,projection_pos.st);

// Bump mapping?
///float3 BumpNormal=tex2D (texture2d_3,UVcoordinates.xy*0.4).xyz*2.0-vec3 (1.0);


// calculate ambient
float4 Ambient_Color=vec4 (0.6);

// calculate diffuse color
vec3 normalized_normal=normalize(normal.xyz);
float dott=dot(normalized_normal.xyz,vec3 (0.0,0.0,1.0));
dott=clamp (dott,0.0,1.0);
dott=pow(dott,2.0);
float4 Diffuse_Color=vec4 (dott)*vec4 (0.3,0.6,1.0,1.0)*1.3;

// calculate specular 
vec3 H=vec3 (0.0,0.0,1.0)+vec3 (0.3,-0.1,0.0);
H=normalize (H);

dott=dot(normalized_normal,H);
dott=clamp (dott,0.0,1.0);
dott=pow(dott,64.0);
float4 Specular_Color=vec4 (dott)*vec4 (0.7,0.8,1.0,1.0);

H=vec3 (-1.65,0,1.0)+vec3 (0.3,-0.1,0.0);
H=normalize (H);
dott=dot(normalized_normal,H);
dott=clamp (dott,0.0,1.0);
dott=pow(dott,32.0);
Specular_Color+=vec4 (dott)*vec4 (1.0,0.6,0.4,0.6)*2.0;


H=vec3 (-1.65,0,1.0)+vec3 (0.3,1.89,0);
H=normalize (H);
dott=dot(normalized_normal,H);
dott=clamp (dott,0.0,1.0);
dott=pow(dott,12.0);
Specular_Color+=vec4 (dott)*vec4 (0.2,0.6,1.6,0.6)*0.4;

// combine all
if (timer1<0.999)
{Final_Color=Ambient_Color+Diffuse_Color*0.3+1.2*Specular_Color;
Final_Color*=Color;
}


// soft shadow mapping
float shadow=1.0;
float divv=(ShadowPosZ.z+0.000)/ShadowPosZ.w;
if (MaterialMultiplier>0.1)
if (ShadowPosZ.w>0.0)
{
	for (int r=0;r<3;r++)
	{
	float Shadow=texture2D (texture2d_2,projection_pos.st+1.1*-6.11*float2 (-0.0002*float (r),-0.0002*float (r))).z;
	if (0.00202+Shadow-1.96*0.001<divv) shadow-=0.149;
	}
}

//Final_Color=vec4 (shadow);
// texture mapping
float4 ftex=tex2D (texture2d_3,MaterialMultiplier*UVcoordinates.xy*0.1+float2 (0.5,0.5));

//Final_Color=vec4 (0.5);
// projection of spot light onto scene (with texture on top)
///float2 ftex=tex2D (texture2d_3,UVcoordinates.xy*0.2+float2 (0.5,0.5)).xy;



Final_Color*=1.0+0.6*ftex;

float2 UVcoords2=projection_position.xz*0.11;

float4 TheNormal=(nnormal.xyzz+float4 (1.0))*0.5;


{

float4 ftexrefl=tex2D (texture2d_paper,MaterialMultiplier*UVcoordinates.xy*0.25);
ftexrefl=ftexrefl+(2.0*TheNormal.yxzz-ftexrefl)*-0.07*ttimer2;

Final_Color=ftexrefl;
Final_Color*=vec4(0.9,0.9,1.0,1.0)+Specular_Color*0.6;
Final_Color*=0.6+tex2D (texture2d_blob,MaterialMultiplier*projection_from_camera.st*0.015+vec2 (0.46))*1.0;
}







float dpth=gl_FragCoord.z/gl_FragCoord.w+0.14*0.001;
dpth*=1.867*0.0056;
dpth=1.0-dpth;

dpth=clamp (dpth,0.0,1.0);
Final_Color*=dpth;
shadow=clamp (shadow*1.4,0.0,1.0);

TheNormal.w=1.0-shadow;
shadow=clamp (shadow*1.0,0.0,1.0);


//Final_Color=MaterialMultiplier*vec4 (1.0);
gl_FragData[0]=TheNormal;


// Back facing culling etc.
///if (!gl_FrontFacing)  {
///	Diffuse.xyz=vec3 (0.8,0.5,0.1);
///	TheNormal.w=1.0;
///}

// cube mapping
///Final_Color=texture (texture2d_cube,nnormal.xyz);

gl_FragData[1]=Final_Color*shadow;

// Depth fragment 
///gl_FragDepth=gl_FragCoord.z+0.02*ftex;
}














